	* kaffe/kaffevm/findInJar.c (classpath): dynamically grow.

Index: kaffe/kaffevm/findInJar.c
===================================================================
RCS file: /home/msc/oliva/src/.cvs/kaffe/kaffe/kaffevm/findInJar.c,v
retrieving revision 1.1.1.8
diff -u -r1.1.1.8 findInJar.c
--- kaffe/kaffevm/findInJar.c	1998/06/13 17:33:40	1.1.1.8
+++ kaffe/kaffevm/findInJar.c	1998/06/13 18:27:22
@@ -55,7 +55,8 @@
 			int	loaded;
 		} sof;
 	} u;
-} classpath[MAXPATHELEM+1];
+} *classpath;
+int classpathlen;
 
 static char* splitClassPath;
 char* realClassPath;
@@ -325,7 +326,15 @@
 	cp = splitClassPath;
 
 PDBG(	printf("initClasspath(): '%s'\n", cp);				)
-	for (i = 0; cp != 0 && i < MAXPATHELEM; i++) {
+	for (i = 0; cp != 0; i++) {
+		if (i >= classpathlen) {
+			void *old = classpath, *new = gc_malloc_fixed(sizeof(*classpath) * (classpathlen + MAXPATHELEM + 1));
+			if (classpath)
+				memcpy(new, classpath, sizeof(*classpath) * (classpathlen));
+			classpath = new;
+			classpathlen += MAXPATHELEM;
+			gc_free(old);
+		}
 		classpath[i].path = cp;
 		cp = strchr(cp, PATHSEP);
 		if (cp != 0) {
@@ -355,17 +364,24 @@
 	}
 
 PDBG(	printf("addClasspath(): '%s'\n", cp);				)
+
+	for (i = 0; ; i++) {
+		if (i >= classpathlen) {
+			void *old = classpath, *new = gc_malloc_fixed(sizeof(*classpath) * (classpathlen + MAXPATHELEM + 1));
+			if (classpath)
+				memcpy(new, classpath, sizeof(*classpath) * (classpathlen));
+			classpath = new;
+			classpathlen += MAXPATHELEM;
+			gc_free(old);
+		}
 
-	for (i = 0; i < MAXPATHELEM; i++) {
 		if (classpath[i].path == 0) {
-			goto found;
+			break;
 		}
 		if (!strcmp(cp, classpath[i].path)) {
 			return(0); /* already in */
 		}
 	}
-	fprintf(stderr, "addClasspath : CLASSPATH is full!\n");
-	return(-1);
 
 	found:
 	classpath[i].path = strdup(cp);
